Program Raszterkepek;          { Raszterkepek transzformalasa: 1990.02.08. }
{
	Megoldsprogram - Szmtgpi grafika (kpnagyts/kicsinyts)
}
uses crt,dos,graph;

  const
       path  = 'c:\langs\bp\bgi\';
       sor   = 100;
       oszlop= 100;
       gx1=  0; gy1=     0;    { grafikus ablak koordinatai }
       gx2=sor; gy2=oszlop;
       px1=sor+10; py1=     0;    { grafikus ablak koordinatai }
       px2=sor*3+10; py2=oszlop;
  type
      keppont     = byte;
      raszterkep  = record
                      sdb,odb: integer;
                      kep    : packed array [0..sor,0..oszlop] of keppont;
                    end;
  var
     k,m,i,j   : integer;
     abra      : raszterkep;
     nabra     : raszterkep;
     f         : file of keppont;
     ch        : char;

  Procedure Karkezd;
  begin
    Window(1,1,80,25);
    TextBackGround(8);
    ClrScr;
  end;

  Procedure Szovegesre;
  begin
    CloseGraph;
    RestoreCrtMode;
  end;

  Procedure Grafikusra;
    var
       gd,gm : integer;
  begin
    gd:=detect; gm:=1;
    InitGraph(gd,gm,path);
    SetBkColor(2);
  end;

  Procedure FileBehozatal;
    var
       i,j: integer;
  begin
    assign(f,'mandelb.kep');
    reset(f);
    abra.sdb:=sor; abra.odb:=oszlop;
    for i:=0 to sor do
    begin
      for j:=0 to oszlop do
      begin
        read(f,abra.kep[i,j]);
      end;
    end;
    close(f);
  end;

  Procedure Nagyit1;
    var
       i,j : integer;
       pont: keppont;
       log : Boolean;
       ment: array [1..12632] of byte;
       ch  : char;
       ks,ko: integer;      { a nagyitando resz kezdete }
  begin
    SetBkColor(0); SetColor(0);
    ks:=0; ko:=0;
    GetImage(gx1,gy1,gx2,gy2,ment);
    repeat
      Rectangle(ko,ks,ko+oszlop div 2,ks+sor div 2);
      ch:=readkey;
      Putimage(gx1,gy1,ment,0);
      case ch of
        #80: if ks<sor div 2    then ks:=ks+1;
        #72: if ks>0            then ks:=ks-1;
        #75: if ko>0            then ko:=ko-1;
        #77: if ko<oszlop div 2 then ko:=ko+1;
        #13: ;
      end;
    until ch=#13;
    SetViewPort(px1,py1,px2,py2,true);
    SetBkColor(0);
    ClearViewPort;
    nabra.sdb:=abra.sdb; nabra.odb:=abra.odb;
    for i:=0 to (sor-1) div 2 do for j:=0 to (oszlop-1) div 2 do
    begin
      pont:=abra.kep[ks+i,ko+j];
      nabra.kep[2*i,2*j]:=pont;
      nabra.kep[2*i+1,2*j]:=pont;
      nabra.kep[2*i,2*j+1]:=pont;
      nabra.kep[2*i+1,2*j+1]:=pont;
      if pont<64  then pont:=1 else if
         pont<192 then pont:=2
                  else pont:=3;
      PutPixel(2*j,2*i,pont);
      PutPixel(2*j+1,2*i,pont);
      PutPixel(2*j,2*i+1,pont);
      PutPixel(2*j+1,2*i+1,pont);
    end;
  end;

  Procedure Nagyit2;
    var
       i,j : integer;
       pont: keppont;
       log : Boolean;
       ment: array [1..12632] of byte;
       ch  : char;
       ks,ko: integer;      { a nagyitando resz kezdete }
  begin
    SetBkColor(0); SetColor(0);
    ks:=0; ko:=0;
    GetImage(gx1,gy1,gx2,gy2,ment);
    repeat
      Rectangle(ko,ks,ko+oszlop div 2,ks+sor div 2);
      ch:=readkey; if ch=chr(0) then ch:=readkey;
      Putimage(gx1,gy1,ment,0);
      case ch of
        #80: if ks<sor div 2    then ks:=ks+1;
        #72: if ks>0            then ks:=ks-1;
        #75: if ko>0            then ko:=ko-1;
        #77: if ko<oszlop div 2 then ko:=ko+1;
        #13: ;
      end;
    until ch=#13;
    SetViewPort(px1,py1,px2,py2,true);
    SetBkColor(0);
    ClearViewPort;
    nabra.sdb:=abra.sdb; nabra.odb:=abra.odb;
    for i:=0 to sor div 2-1 do for j:=0 to oszlop div 2-1 do
    begin
      pont:=abra.kep[ks+i,ko+j];
      nabra.kep[2*i,2*j]:=pont;
      nabra.kep[2*i+1,2*j]:=(pont+abra.kep[ks+i+1,ko+j]) div 2;
      nabra.kep[2*i,2*j+1]:=(pont+abra.kep[ks+i,ko+j+1]) div 2;
      nabra.kep[2*i+1,2*j+1]:=(pont+abra.kep[ks+i+1,ko+j+1]) div 2;
      if pont<63  then pont:=1 else if
         pont<191 then pont:=2
                  else pont:=3;
      PutPixel(2*j,2*i,pont);
      PutPixel(2*j+1,2*i,pont);
      PutPixel(2*j,2*i+1,pont);
      PutPixel(2*j+1,2*i+1,pont);
    end;
  end;

  Procedure Kicsinyit1;
    var
       i,j : integer;
       pont: keppont;
  begin
    SetViewPort(px1,py1,px2,py2,true);
    SetBkColor(0);
    ClearViewPort;
    nabra.sdb:=abra.sdb div 2; nabra.odb:=abra.odb div 2;
    for i:=0 to abra.sdb div 2 do for j:=0 to abra.odb div 2 do
    begin
      pont:=abra.kep[2*i,2*j];
      nabra.kep[i,j]:=pont;
      if pont<63  then pont:=1 else if
         pont<191 then pont:=2
                  else pont:=3;
      PutPixel(j,i,pont);
      PutPixel(oszlop+2*j,2*i,pont);
      PutPixel(oszlop+2*j+1,2*i,pont);
      PutPixel(oszlop+2*j,2*i+1,pont);
      PutPixel(oszlop+2*j+1,2*i+1,pont);
    end;
  end;

  Procedure Kicsinyit2;
    var
       i,j : integer;
       pont: keppont;
  begin
    SetViewPort(px1,py1,px2,py2,true);
    SetBkColor(0);
    ClearViewPort;
    nabra.sdb:=abra.sdb div 2; nabra.odb:=abra.odb div 2;
    for i:=0 to (abra.sdb-1) div 2 do for j:=0 to (abra.odb-1) div 2 do
    begin
      pont:=(abra.kep[2*i,2*j]+abra.kep[2*i+1,2*j]+abra.kep[2*i,2*j+1]+
             abra.kep[2*i+1,2*j+1]) div 4;
      nabra.kep[i,j]:=pont;
      if pont<63  then pont:=1 else if
         pont<191 then pont:=2
                  else pont:=3;
      PutPixel(j,i,pont);
      PutPixel(oszlop+2*j,2*i,pont);
      PutPixel(oszlop+2*j+1,2*i,pont);
      PutPixel(oszlop+2*j,2*i+1,pont);
      PutPixel(oszlop+2*j+1,2*i+1,pont);
    end;
  end;

  Procedure Rajzol;
    var
       i,j : integer;
       pont: keppont;
  begin
    SetViewPort(gx1,gy1,gx2,gy2,true);
    SetBkColor(0);
    ClearViewPort;
    for i:=0 to abra.sdb do for j:=0 to abra.odb do
    begin
      pont:=abra.kep[i,j];
      if pont<63  then pont:=1 else if
         pont<191 then pont:=2
                  else pont:=3;
      PutPixel(j,i,pont);
    end;
  end;

  Procedure Menuszoveg;
  begin
    SetViewPort(0,sor+20,319,179,true);
    SetColor(3); ClearViewPort;
    OuttextXY(10,0,'Hasznlhato billentyuk:');
    OuttextXY(20,20,'kurzor: ablakmozgats');
    OuttextXY(20,28,'ENTER : nagyits');
  end;

  Procedure Menuszoveg2;
  begin
    SetViewPort(0,sor+20,319,179,true);
    SetColor(3); ClearViewPort;
    OuttextXY(10,0,'Hasznlhato billentyuk:');
    OuttextXY(20,28,'ESC  : vge');
    OuttextXY(20,20,'ENTER: kicsinyits');
  end;

  Procedure Kepvalasztas(var i:integer;var ch:char);
  begin
    SetViewPort(0,sor+20,319,179,true);
    SetColor(3);  ClearViewPort;
    OuttextXY(10,0,'Hasznlhato billentyuk:');
    OuttextXY(20,28,'ENTER : nagyits');
    OutTextXY(20,20,'kurzor: aktulis kp  ');
    OutTextXy(20,36,'ESC   : vge');
    SetViewPort(0,0,319,199,true);
    repeat
      SetColor(3); OutTextXY((i-1)*oszlop+oszlop div 2,sor+10,'^');
      ch:=readkey;
      SetColor(0); OutTextXY((i-1)*oszlop+oszlop div 2,sor+10,'^');
      if ch=#77 then i:=2;
      if ch=#75 then i:=1;
    until (ch=#13) or (ch=#27);
    SetColor(3);
  end;

  Procedure Nagyitsokszor;
  begin
    SetViewPort(0,0,319,199,true); ClearViewPort;
    OutTextXY(40,180,'Nagyits pontsokszorozssal');
    FileBehozatal;
    Menuszoveg;
    repeat
      Rajzol;
      Nagyit1;
      i:=1; Kepvalasztas(i,ch);
      if i=2 then abra:=nabra;
    until ch=#27;
  end;

  Procedure Nagyitatlag;
  begin
    SetViewPort(0,0,319,199,true); ClearViewPort;
    OutTextXY(40,180,'Nagyits tlagolssal');
    Filebehozatal;
    Menuszoveg;
    repeat
      Rajzol;
      Nagyit2;
      i:=1; Kepvalasztas(i,ch);
      if i=2 then abra:=nabra;
    until ch=#27;
  end;

  Procedure Kicsinyitelhagy;
  begin
    SetViewPort(0,0,319,199,true); ClearViewPort;
    OutTextXY(40,180,'Kicsinyits pontelhagyssal');
    Filebehozatal;
    repeat
      Rajzol;
      Kicsinyit1; abra:=nabra;
      Menuszoveg2;
      ch:=readkey;
    until ch=#27;
  end;

  Procedure Kicsinyitatlag;
  begin
    SetViewPort(0,0,319,199,true); ClearViewPort;
    OutTextXY(40,180,'Kicsinyits tlagolssal');
    Filebehozatal;
    repeat
      Rajzol;
      Kicsinyit2; abra:=nabra;
      Menuszoveg2;
      ch:=readkey;
    until ch=#27;
  end;

  Procedure Mozgat;
    var tomb: array [1..10000] of byte;
        tom : array [1..1000] of byte;
        c   : char;
        i   : Integer;
  begin
    FileBehozatal;
    Rajzol;
    SetViewPort(gx1,gy1,gx2*2,gy2,true);
    GetImage(gx1,gy1,gx2,gy2,tomb);
    for i:=0 to gx2 do PutImage(gx1+i,gy1,tomb,copyput);
    c:=readkey;
    PutImage(gx1,gy1,tomb,copyput);
    for i:=1 to 100 do
    begin
      getimage(gx1,gy1,gx1,gy2,tom);
      getimage(gx1+1,gy1,gx2,gy2,tomb);
      putimage(gx1,gy1,tomb,copyput);
      putimage(gx2,gy1,tom,copyput);
    end;
    c:=readkey;
  End;

  Function fomenu:integer;
    const
         msz : array [1..6] of string =
               ('1 - nagyits pontsokszorozssal',
                '2 - nagyits tlagolssal',
                '3 - kicsinyits pontelhagyssal',
                '4 - kicsinyits tlagolssal',
                '5 - mozgats',
                '6 - vge');
    var
       k       : char;
       ev,av,i : integer;
  begin
    TextColor(2);
    GotoXY(30,1); Writeln('Raszterkpek transzformlsa');
    for i:=1 to 6 do
    begin
      GotoXY(13,10+(i-1)); writeln(msz[i]);
    end;
    av:=1; ev:=1;
    repeat
      TextColor(2); GotoXY(13,10+(ev-1)); Writeln(msz[ev]);
      TextColor(4); GotoXY(13,10+(av-1)); Writeln(msz[av]);
      k:=readkey; if k=#0 then k:=readkey;
      ev:=av;
      case k of
        'P' : begin     { lefele }
                av:=av+1;
                if av>6 then av:=1;
              end;
        'H' : begin     { felfele }
                av:=av-1;
                if av<1 then av:=6;
              end;
        '1' : begin av:=1; k:=#13; end;
        '2' : begin av:=2; k:=#13; end;
        '3' : begin av:=3; k:=#13; end;
        '4' : begin av:=4; k:=#13; end;
        '5' : begin av:=5; k:=#13; end;
        '6' : begin av:=6; k:=#13; end;
      end;
    until k=#13;
    fomenu:=av;
  end;

  begin          { foprogram }
    Karkezd;
    repeat
      i:=fomenu;
      if i<6 then Grafikusra;
      case i of
        1: Nagyitsokszor;
        2: Nagyitatlag;
        3: Kicsinyitelhagy;
        4: Kicsinyitatlag;
        5: Mozgat;
      end;
      if i<6 then Szovegesre;
    until i=6;
  end.
