Program NagyitasKicsinyitesStb;
{ --------------------------------------------------------------------------
	Nagyts, kicsinyts s lkiemels. (Szmtgpi grafikhoz)

        (Adott 2-vltozs grbe generlsa utn.)

	Keretprogram.
  -------------------------------------------------------------------------- }
{$f+ azrt kell, hogy fggvnyt paramterknt adhassak t }
  Uses
      NewDelay,Crt,Graph;
  Const
      MaxN = 100;                    {Maximum ennyi pontbl llhat a fggvny}
      Hol_a_BGI='e:\LANGS\BP\BGI';                {Itt tallhat a BGI-driver}
{ ------------------- A kirajzoland fggvnyek megadsa: ------------------ }
  Type
      KetValtozosFv = Record
                        tolX,igX,tolY,igY:Real; {A fv. rtelmezsi tartomnya}
                        fv: Function(x,y:Real):Real; {A fv.-t kiszmol FUNC.}
                        min,max:Real                     {A fv. rtkkszlete}
                      End;
  Function x_(x,y:Real): Real;
  Begin
    x_:=x/100;
  End;
  Function x_y(x,y:Real): Real;
  Begin
    x_y:=x*y/100;
  End;
  Function xHullam_(x,y:Real): Real;
  Begin
    xHullam_:=Sin(x);
  End;
  Function Sinx_Siny(x,y:Real): Real;
  Begin
    Sinx_Siny:=Sin(x)*Sin(y);
  End;
  Function x_Cosy(x,y:Real): Real;
  Begin
    x_Cosy:=x*Cos(x);
  End;
  Function ForgEllipsz(x,y:Real): Real;
  Begin
    ForgEllipsz:=2*Sqr(x)+0.5*Sqr(y);
  End;

    {
      Itt gyelni kell, hogy a fggvnyek maximuma s minimuma helyes legyen,
      tovbb a sszhangban lljon a MaxN s az rtelmezsi tartomny lps-
      kze!!!
    }
  Const
      x_Fv      : KetValtozosFv=(tolX:-4.92;igX:4.92;tolY:-4.92;igY:4.92;
                                 fv:x_; min:-2.0; max:2.0);
      x_yFv     : KetValtozosFv=(tolX:-4.92;igX:4.92;tolY:-4.92;igY:4.92;
                                 fv:x_y; min:-2.0; max:2.0);
      xHullam_Fv: KetValtozosFv=(tolX:-4.92;igX:4.92;tolY:-4.92;igY:4.92;
                                 fv:xHullam_; min:-1.0; max:1.0);
      sin_sinFv : KetValtozosFv=(tolX:-4.92;igX:4.92;tolY:-4.92;igY:4.92;
                                 fv:Sinx_Siny; min:-1.0; max:1.0);
      x_CosFv   : KetValtozosFv=(tolX:-pi;igX:pi;tolY:-pi;igY:pi;
                                 fv:x_Cosy; min:-pi; max:pi);
      ForgEllipszFv: KetValtozosFv=(tolX:-4.92;igX:4.92;tolY:-4.92;igY:4.92;
                                    fv:ForgEllipsz; min:-0; max:75);
{ ---------------- A fggvnyrtkeket tartalmaz vektorok: ---------------- }
  Type
      FvErtek       = Array [1..MaxN,1..MaxN] of Byte;
      FuggvenyTabla = Record
                        n,m: Integer;
                        fv : FvErtek;
                      End;
  Var
      ft: Array [0..3] of FuggvenyTabla;
{ -------------------------- A megjelent ablakok: ------------------------ }
  Type
      Ablak = Record
                bf,ja: Record x,y: Integer; End;
                cimke: String;
                szin : Integer;
              End;
  Var
      a: Array [1..7] of Ablak;
      szel,
      mag: Integer; {Aktulis szlessgk s magassguk}
      XMax,YMax,
      XMin,YMin: Integer;   { A teljes kperny mretei}
{ ------------------------ Egyb globlis vltozk: ------------------------ }
      x: Real;

  Procedure Inic;
    Var gd,gm,
        i : Integer;
  Begin
    gd:=Detect;
    InitGraph(gd,gm,Hol_a_BGI);
    If GraphResult<>0 then
    Begin
      Writeln(' Legyen az aktlis alknyvtrban a megfelel BGI llomny!');
      Halt(1);
    End;
    SetBkColor(Black);                          {A httrszn legyen: fekete}
    ClearDevice;
    XMax:=GetMaxX; YMax:=GetMaxY;
    XMin:=0; YMin:=0;
    SetColor(White);                             {Az tintaszn legyen: fehr}
    Rectangle(XMin,YMin, XMax,YMax);
    szel:=(XMax Div 2)-4; mag:=(YMax Div 2)-TextHeight(' ');
    SetTextJustify(CenterText,TopText);         {A kirs "origja" a szveg}
    OutTextXY(szel+1,2,'Nagyt program');      {     fels szlnek kzepe }
    With a[1] do
    Begin
       bf.x:=2; bf.y:=10;
       ja.x:=szel-2; ja.y:=mag+8; cimke:='Eredeti'; szin:=Red
    End;
    With a[2] do
    Begin
       bf.x:=XMax-2-szel; bf.y:=10;
       ja.x:=XMax-2; ja.y:=mag+8;
       cimke:='Nagyts duplzva'; szin:=Blue
    End;
    With a[3] do
    Begin
       bf.x:=2; bf.y:=YMax-2-mag;
       ja.x:=szel-2; ja.y:=YMax-2;
       cimke:='Nagyts tlagolva'; szin:=Green
    End;
    With a[4] do
    Begin
       bf.x:=XMax-2-szel; bf.y:=YMax-2-mag;
       ja.x:=XMax-2-(szel Div 2); ja.y:=YMax-2-(mag Div 2);
       cimke:='Elhagy kicsnyts'; szin:=Yellow
    End;
    With a[5] do
    Begin
       bf.x:=XMax-2-(szel Div 2); bf.y:=YMax-2-mag;
       ja.x:=XMax-2; ja.y:=YMax-2-(mag Div 2);
       cimke:='Atlag-kicsinyts'; szin:=Yellow
    End;
    With a[6] do
    Begin
       bf.x:=XMax-2-szel; bf.y:=YMax-2-(mag Div 2);
       ja.x:=XMax-2-(szel Div 2); ja.y:=YMax-2;
       cimke:='lkiemels:'; szin:=Cyan
    End;
    With a[7] do
    Begin
       bf.x:=XMax-2-(szel Div 2); bf.y:=YMax-2-(mag Div 2);
       ja.x:=XMax-2; ja.y:=YMax-2;
       cimke:='lkiemels:-K'; szin:=Cyan
    End;
    For i:=1 to 7 do
      With a[i] do
      Begin
         SetColor(szin);
         SetViewPort(bf.x,bf.y, ja.x,ja.y,ClipOn);
         Rectangle(0,0, (ja.x-bf.x)-4,(ja.y-bf.y)-4);
         OutTextXY((ja.x-bf.x) Div 2,1,cimke);
      End;
  End;

  Procedure Feltolt(f: KetValtozosFv; lepX,lepY: Real; Var ft: FuggvenyTabla);
     Var x,y: Real; i,j: Integer;
  Begin
    With f do {"f." kiemelse az "f.*" mezhivatkozsokbl}
    Begin
      y:=tolY; i:=0;
      While y<=igY do
      Begin
        Inc(i); x:=tolX; j:=0;
        While x<=igX do
        Begin
          Inc(j);
          ft.fv[i,j]:=Round((fv(x,y)-min)*((MaxN-1)/(max-min)));
          x:=x+lepX;
        End;{of While x}
        y:=y+lepY;
        ft.m:=j;
      End;{of While y}
      ft.n:=i;
    End;{of With}
  End;

  Procedure FolyoGeneralas(Var ft: FuggvenyTabla);
    Var mag,i,i0,j,j0: Integer;

    Procedure Arkotas(Var i0,j0:Integer; ri1,ri2,rj1,rj2:Real);
      Var r:Real; i,m,db:Integer;
    Begin
      db:=0; m:=ft.Fv[i0,j0];
      While (i0 in [3..ft.N-2]) and (j0 in [3..ft.M-2]) do
      Begin
        r:=Random;
        If
          r<ri1     then i:=i0+1 else if
          r<ri1+ri2 then i:=i0
                    else i:=i0-1;
        r:=Random;
        If
          r<rj1     then j:=j0+1 else if
          r<rj1+rj2 then j:=j0
                    else j:=j0-1;
        ft.Fv[i,j]:=m; ft.Fv[i+1,j]:=m; ft.Fv[i,j+1]:=m; ft.Fv[i+1,j+1]:=m;
        i0:=i; j0:=j;
        Inc(db);
      End{While};
      For i:=1 to Random(db) do
      Begin
        If
          ft.Fv[i0-1,j0]=m   then Dec(i0) else if
          ft.Fv[i0,j0-1]=m   then Dec(j0) else if
          ft.Fv[i0-1,j0-1]=m then Begin Dec(i0); Dec(j0) End else if
          ft.Fv[i0+1,j0]=m   then Inc(j0) else if
          ft.Fv[j0,j0+1]=m   then Inc(j0)
        {EndIf};
      End{For};
    End;

  Begin {FolyGeneralas}
    ft.n:=MaxN; ft.M:=MaxN;
    For i:=1 to ft.N do for j:=1 to ft.M do
    Begin
      ft.Fv[i,j]:=100;
    End;
    i0:=15; j0:=15;
    ft.Fv[i0,j0]:=ft.Fv[i0,j0]-Random(9)+4;
    mag:=ft.Fv[i0,j0];
    Arkotas(i0,j0,0.3,0.5,0.3,0.4);
    Arkotas(i0,j0,0.9,0.1,0.8,0.1);

    i0:=45; j0:=15;
    ft.Fv[i0,j0]:=mag;
    Arkotas(i0,j0,0.3,0.5,0.4,0.4);
    Arkotas(i0,j0,0.9,0.1,0.9,0.1);

    i0:=30; j0:=30;
    ft.Fv[i0,j0]:=mag;
    Arkotas(i0,j0,0.2,0.7,0.4,0.4);
    Arkotas(i0,j0,0.9,0.1,0.9,0.1);

    i0:=65; j0:=90;
    ft.Fv[i0,j0]:=mag;
    Arkotas(i0,j0,0.2,0.1,0.1,0.1);
  End;

  Procedure Kirajzol(a: Ablak; t: FuggvenyTabla);
    Var i,j: Integer;
  Begin
     With a do
     Begin
       SetViewPort(bf.x+2,bf.y+1+TextHeight(' '),ja.x-2,ja.y-2,ClipOff);
       For i:=1 to t.n do for j:=1 to t.m do
       Begin
         PutPixel(i,j,t.fv[j,i])
       End;
     End;
  End;

  Procedure NagyitDuplazva(a: Ablak; t: FuggvenyTabla);
    Var i,j: Integer;
  Begin
     { ide kell valami }
  End;

  Procedure NagyitAtlagolva(a: Ablak; t: FuggvenyTabla);
    Var i,j: Integer; fv,fvA: Byte;
  Begin
     { ide kell valami }
  End;

  Procedure KicsinyitElhagyva(a: Ablak; t: FuggvenyTabla);
    Var i,j: Integer; fv,fvA: Byte;
  Begin
     { ide kell valami }
  End;

  Procedure KicsinyitAtlagolva(a: Ablak; t: FuggvenyTabla);
    Var i,j: Integer; fvA: Byte;
  Begin
     { ide kell valami }
  End;

  Type Irany=(Eszak, EszakKelet, Kelet, Del, Nyugat);

  Procedure Elkiemeles(a: Ablak; t: FuggvenyTabla; merrol: Irany);
    Var i,j,kx,ky: Integer; fvA: Real;
    Const mennyire: Array [Irany,-1..1,-1..1] of Real=
                          (((0.0,-1.0,0.0),
                            (0.0,1.0,0.0),
                            (0.0,0.0,0.0)), {Eszak}
                           ((0.0,0.0,-1.0),
                            (0.0,1.0,0.0),
                            (0.0,0.0,0.0)), {EszakKelet}
                           ((0.0,0.0,0.0),
                            (0.0,1.0,-1.0),
                            (0.0,0.0,0.0)), {Kelet}
                           ((0.0,0.0,0.0),
                            (0.0,-1.0,0.0),
                            (0.0,1.0,0.0)), {Del}
                           ((0.0,0.0,0.0),
                            (0.0,-1.0,1.0),
                            (0.0,0.0,0.0))  {Nyugat});
  Begin
     { ide kell valami }
  End;

Begin
  FolyoGeneralas(ft[0]);
  Feltolt({Sin_SinFv}ForgEllipszFv, 0.1,0.1, ft[1]);
  Feltolt(Sin_SinFv{ForgEllipszFv}, 0.1,0.1, ft[2]);
  Feltolt(x_yFv, 0.1,0.1, ft[3]);

  Inic;
  Kirajzol(a[1],ft[0]);
  NagyitDuplazva(a[2],ft[0]);      NagyitAtlagolva(a[3],ft[0]);
  KicsinyitElhagyva(a[4],ft[0]);   KicsinyitAtlagolva(a[5],ft[0]);
  Elkiemeles(a[6],ft[0],Eszak);    Elkiemeles(a[7],ft[0],EszakKelet);
  ReadKey;

  Inic;
  Kirajzol(a[1],ft[1]);
  NagyitDuplazva(a[2],ft[1]);      NagyitAtlagolva(a[3],ft[1]);
  KicsinyitElhagyva(a[4],ft[1]);   KicsinyitAtlagolva(a[5],ft[1]);
  Elkiemeles(a[6],ft[1],Eszak);    Elkiemeles(a[7],ft[1],EszakKelet);
  ReadKey;

  Inic;
  Kirajzol(a[1],ft[2]);
  NagyitDuplazva(a[2],ft[2]);      NagyitAtlagolva(a[3],ft[2]);
  KicsinyitElhagyva(a[4],ft[2]);   KicsinyitAtlagolva(a[5],ft[2]);
  Elkiemeles(a[6],ft[2],Eszak);    Elkiemeles(a[7],ft[2],EszakKelet);
  ReadKey;

  Inic;
  Kirajzol(a[1],ft[3]);
  NagyitDuplazva(a[2],ft[3]);      NagyitAtlagolva(a[3],ft[3]);
  KicsinyitElhagyva(a[4],ft[3]);   KicsinyitAtlagolva(a[5],ft[3]);
  Elkiemeles(a[6],ft[3],Eszak);    Elkiemeles(a[7],ft[3],EszakKelet);
  ReadKey;

  CloseGraph
End.